﻿namespace Collections
{
	public abstract class Shape
	{
		public delegate void SizeChangeNotification(Shape shape);
		public event SizeChangeNotification SizeChanged;

		private Dimension size;

		public Shape(Dimension size)
		{
			Size = size;
		}
		public Dimension Size
		{
			get { return size; }
			set
			{
				if (size != value)
				{
					size.Width = value.Width;
					size.Height = value.Height;
					if (SizeChanged != null)
						SizeChanged(this);
				}
			}

		}

		public abstract double CalcArea();

		public override string ToString()
		{
			return $"A shape with an area of {CalcArea()}";
		}


	}

}
